## org.apache.commons.collections.map
Class TransformedSortedMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.TransformedMap
              org.apache.commons.collections.map.TransformedSortedMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map, java.util.SortedMap

    public class TransformedSortedMap

extends TransformedMap
implements java.util.SortedMap

Decorates another `SortedMap` to transform objects that are added.

The Map put methods and Map.Entry setValue method are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

Note that TransformedSortedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedSortedMap(java.util.SortedMap)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.TransformedMap
`keyTransformer, valueTransformer`

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `TransformedSortedMap(java.util.SortedMap map, Transformer keyTransformer, Transformer valueTransformer)` Constructor that wraps (not copies).

Method Summary
`java.util.Comparator` `comparator()`
`static java.util.SortedMap` `decorate(java.util.SortedMap map, Transformer keyTransformer, Transformer valueTransformer)` Factory method to create a transforming sorted map.
`static java.util.SortedMap` `decorateTransform(java.util.SortedMap map, Transformer keyTransformer, Transformer valueTransformer)` Factory method to create a transforming sorted map that will transform existing contents of the specified map.
`java.util.Set` `entrySet()`
`java.lang.Object` `firstKey()`
`protected java.util.SortedMap` `getSortedMap()` Gets the map being decorated.
`java.util.SortedMap` `headMap(java.lang.Object toKey)`
`java.lang.Object` `lastKey()`
`java.util.SortedMap` `subMap(java.lang.Object fromKey, java.lang.Object toKey)`
`java.util.SortedMap` `tailMap(java.lang.Object fromKey)`

Methods inherited from class org.apache.commons.collections.map.TransformedMap
`checkSetValue, decorate, decorateTransform, isSetValueChecking, put, putAll, transformKey, transformMap, transformValue`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, equals, get, getMap, hashCode, isEmpty, keySet, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### TransformedSortedMap

    protected TransformedSortedMap(java.util.SortedMap map,
                                   Transformer keyTransformer,
                                   Transformer valueTransformer)

  Constructor that wraps (not copies).

  If there are any elements already in the collection being decorated, they are NOT transformed.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the predicate to validate the keys, null means no transformation
    `valueTransformer` - the predicate to validate to values, null means no transformation
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null

Method Detail

### decorate

    public static java.util.SortedMap decorate(java.util.SortedMap map,
                                               Transformer keyTransformer,
                                               Transformer valueTransformer)

  Factory method to create a transforming sorted map.

  If there are any elements already in the map being decorated, they are NOT transformed. Constrast this with `decorateTransform(java.util.SortedMap, org.apache.commons.collections.Transformer, org.apache.commons.collections.Transformer)`.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the predicate to validate the keys, null means no transformation
    `valueTransformer` - the predicate to validate to values, null means no transformation
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null

### decorateTransform

    public static java.util.SortedMap decorateTransform(java.util.SortedMap map,
                                                        Transformer keyTransformer,
                                                        Transformer valueTransformer)

  Factory method to create a transforming sorted map that will transform existing contents of the specified map.

  If there are any elements already in the map being decorated, they will be transformed by this method. Constrast this with `decorate(java.util.SortedMap, org.apache.commons.collections.Transformer, org.apache.commons.collections.Transformer)`.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the transformer to use for key conversion, null means no transformation
    `valueTransformer` - the transformer to use for value conversion, null means no transformation
  Throws:
    `java.lang.IllegalArgumentException` - if map is null
  Since:
    Commons Collections 3.2

### getSortedMap

    protected java.util.SortedMap getSortedMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### firstKey

    public java.lang.Object firstKey()

  Specified by:
    `firstKey` in interface `java.util.SortedMap`

### lastKey

    public java.lang.Object lastKey()

  Specified by:
    `lastKey` in interface `java.util.SortedMap`

### comparator

    public java.util.Comparator comparator()

  Specified by:
    `comparator` in interface `java.util.SortedMap`

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Specified by:
    `subMap` in interface `java.util.SortedMap`

### headMap

    public java.util.SortedMap headMap(java.lang.Object toKey)

  Specified by:
    `headMap` in interface `java.util.SortedMap`

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object fromKey)

  Specified by:
    `tailMap` in interface `java.util.SortedMap`

### entrySet

    public java.util.Set entrySet()

  Specified by:
    `entrySet` in interface `java.util.Map`
  Overrides:
    `entrySet` in class `AbstractMapDecorator`

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.